{% extends 'profile/layouts/admin/admin_layout.html' %}

{% load static %}
{% load humanize %}
{% load mathfilters %}
{% load custom_tags %}

{% block css %}
    <style>
        .img-bagss {
            position: absolute;
            top: 0;
            background-color: rgba(255, 0, 0, 0.8);
            text-align: center;
            font-weight: 500;
            line-height: 16px;
            padding: 5px 10px;
            color: #FFFFFF;
            border-radius: 5px 5px 5px 0;
        }
        .img-bagss .tag-bln { font-size: 15px; }
    </style>
{% endblock css %}

{% block navbar %}
    {% include 'profile/layouts/admin/navbar.html' %}
{% endblock navbar %}

{% block main %}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{% url 'profile:admin_home' %}">Home</a></li>
            <li class="breadcrumb-item active" aria-current="page">Managemen Berkas - Faktur Tagihan</li>
        </ol>
    </nav>

    {% if messages %}
        {% for message in messages %}
            <div class="alert {{ message.tags }} my-2" role="alert">
                {{message}}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>  
        {% endfor %}
    {% endif %}

    <div class="card shadow mb-5">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <h6 class="m-0 font-weight-bold text-info"><i class="fa fa-list"></i> Data Faktur Tagihan</h6>
            <div class="dropdown no-arrow">
                <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                </a>
            </div>
            <div class="card-title">
                <div class="col-md-12">
                    <div class="input-group">
                      <input type="text" data-kt-user-table-filter="search" class="form-control form-control-solid w-500px ps-13 filter" aria-describedby="basic-addon2" data-filter="query" placeholder="Cari Data" />
                      <div class="input-group-append">
                        <button class="form-control btn  btn-warning" onclick="filter_data(this, event, false)">Cari</button>
                        <button class="form-control btn  btn-danger" onclick="filter_data(this, event, true)">Reset</button>
                      </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-12">
                    <div class="table-responsive">
                        {% include 'profile/layouts/admin/pagination.html' %}
                        <table class="table table-striped table-bordered" id="table-list">
                            <thead class="bg-primary text-white">
                                <tr>
                                    <th class="text-center align-middle">No</th>
                                    <th class="text-center align-middle">NO SPK</th>
                                    <th class="text-center align-middle">SKPD</th>
                                    <th class="text-center align-middle">Kegiatan</th>
                                    <th class="text-center align-middle">Uraian Pekerjaan</th>
                                    <th class="text-center align-middle">Perusahaan</th>
                                    <th class="text-center align-middle">No Faktur</th>
                                    <th class="text-center align-middle">Pajak</th>
                                    <th class="text-center align-middle">Aksi</th>
                                </tr>
                            </thead>
                            <tbody>
                                {% for item_spk in page_obj %}
                                    <tr>
                                        <td>{{ forloop.counter0|add:page_obj.start_index }}</td>
                                        <td>{{item_spk.nospk}}</td>
                                        <td>{{item_spk.opd.namaopd}} {{item_spk.opd.lokasi.provinsi}} / {{item_spk.opd.lokasi.kabupaten}}</td>
                                        <td>{{item_spk.subkegiatan.kegiatan_nama}}</td>
                                        <td>{{item_spk.uraipekerjaan}}</td>
                                        <td>{{item_spk.perusahaan.namaperusahaan}}</td>
                                        <td>
                                            {% if item_spk.fakturpajak_set.all %}
                                            {% for item_faktur in FAKTURTAGIHAN_list  %}
                                            {% if item_faktur.SPK_id == item_spk.id  %}
                                                {{item_faktur.nofaktur}}
                                            
                                            {% endif %}
                                         {% endfor %}
                                         {% else %}
                                         <div class="d-flex">
                                            <div class="flex-fill-right">
                                                <div class="d-flex badge badge-danger text-center align-middle p-1">
                                                    <i class="bi bi-exclamation-triangle mx-1"></i>
                                                        <span class="icon text-red-100 my-1" style="font-size: 9px;">
                                                            Belum mengisi Faktur
                                                       </span>
                                                </div>
                                            </div>
                                        </div>
                                        {% endif %}
                                        </td>
                                       
                                        <td>
                                            {% if item_spk.spp_set.all %}
                                                {% for item_spp in permohonan_list %}
                                                    {% if item_spp.SPK_id == item_spk.id %}
                                                    <span>Total Tagihan : Rp. {{item_spk.total_tagihan|intcomma}}</span>
                                                    {% endif %}
                                                        
                                                {% endfor %}
                                            {% else %}
                                            {% endif %}
                                            
                                            <ul>
                                                {% if item_spk.fakturpajakrincian_set.all %}
                                                {% for rinc_pjk in fakturpajakrincian_list %}
                                                    {% if item_spk.id == rinc_pjk.SPK_id %}
                                                        <li> {{rinc_pjk.jenispajak}} -  {{rinc_pjk.nilaipajak|intcomma}}</li>
                                                    {% endif %}
                                                {% endfor %}
                                                {% else %}
                                                <div class="d-flex badge badge-danger text-center align-middle p-1">
                                                    <i class="bi bi-exclamation-triangle mx-1"></i>
                                                        <span class="icon text-red-100 my-1" style="font-size: 9px;">
                                                            Tidak Ada Rincian Pajak
                                                       </span>
                                                </div>
                                                {% endif %}
                                            </ul>
                                           
                                        </td>
                                      
                                        <td>
                                            <div class="d-flex align-items-center justify-content-center px-3 py-2 mt-2">
    
                                                <div class="btn-group" role="group" aria-label="Button group with nested dropdown">
                                                  
                                                    <div class="btn-group" role="group">
                                                      <button type="button" class="btn btn-sm btn-info dropdown-toggle" data-toggle="dropdown">
                                                        <i class="bi bi-gear"></i> Aksi
                                                      </button>
                                                      <div class="dropdown-menu">
                                                        {% if item_spk.fakturpajak_set.all %}
                                                        <a class="dropdown-item" href="{% url 'profile:admin_faktur_detail' item_spk.id %}">
                                                            <i class="fa fa-eye"></i> Detail
                                                        </a>
                                                            {% with item_spk.fakturpajak_set.first as faktur %}
                                                                <button class="dropdown-item"
                                                                        onclick="EditFaktur(this)"
                                                                        data-alt="{% url 'profile:admin_managemen_edit_no_faktur' faktur.id %}"
                                                                        data-modal-title="Edit Faktur Tagihan">
                                                                    <span class="fa fa-edit"></span>  Edit
                                                                </button>
                                                            {% endwith %}
                                                        {% else %}
                                                        <button class=" dropdown-item" onclick="TambahFaktur(this)" data-alt="{% url 'profile:admin_managemen_create_no_faktur' item_spk.id %}" data-modal-title="Tambah Faktur Tagihan"><span class="fa fa-edit"></span>  Tambah</button>
                                                        {% endif %}
                                                        {% if item_spk.fakturpajak_set.all and item_spk.fakturpajakrincian_set.all %}
                                                        <button class="dropdown-item " onclick="PrintFaktur(this)" data-alt="{% url 'profile:admin_managemen_print_faktur_tagihan' item_spk.id %}" data-modal-title="Print Faktur Tagihan"><i class="fa fa-print"></i> Print Faktur </button>
                                                        <button class="dropdown-item " onclick="PrintFakturBAP(this)" data-alt="{% url 'profile:admin_managemen_load_modal_bap' item_spk.id %}" data-modal-title="Print Berita Acara Pembayaran (BAP)"><i class="fa fa-print"></i> Print BAP </button>
                                                        {% endif %}
                                                        
                                                      </div>
                                                    </div>
                                                  </div>
                                                
                                            </div>
                                        </td>
                                    </tr>
                                {% endfor %}
                            </tbody>
                        </table>
                        {% include 'profile/layouts/admin/pagination.html' %}
                    </div>
                </div>
            </div>
        </div>
    </div>

{% endblock main %}

{% block footer %}
    {% include 'profile/layouts/admin/footer.html' %}
{% endblock footer %}

{% block scripts_bawah %}
    <script>
        function TambahFaktur(e){
            showModal(e, {size : 'fullscreen'})
        }
        
        function EditFaktur(e){
            showModal(e, {size : 'fullscreen'})
        }
        function Print_Faktur(e, ev){
            ShowIframeReport(
                `${$(e).data('url')}?tanggal=${encodeURIComponent($('#tglprint').val())}`,
                'Cetak Faktur Tagihan',
                ev
            );
        }
        function PrintFaktur(e){
            showModal(e, {size : 'large'})
        }
        
        function Print_Faktur_bap(e, ev){
            ShowIframeReport(
                `${$(e).data('url')}?tanggal=${encodeURIComponent($('#tglprint').val())}&pptk=${encodeURIComponent($('#pptkbap').val())}&pengguna=${encodeURIComponent($('#penggunabap').val())}`,
                'Cetak Faktur Tagihan',
                ev
            );
            
        }
        function PrintFakturBAP(e){
            showModal(e, {size : 'large'})
        }
        
        function updateTanggal(id) {
            const dateInput = $('#tglbapaaaaaaa-' + id).val();
            const uraiTglInput = $('#uraitgl-' + id);
            
            if (dateInput) {
                // Convert the date input to a readable format
                const date = new Date(dateInput);
                const day = date.getDate();
                const month = date.toLocaleString('id-ID', { month: 'long' });
                const year = date.getFullYear();
                
                // Convert the day and year to words
                const dayInWords = convertDayToWords(day);
                const yearInWords = convertYearToWords(year);
                
                // Format the full date in words (e.g., "dua puluh Januari dua ribu dua lima")
                const formattedDate = `${dayInWords} ${month} ${yearInWords}`;
        
                // Set the value of the "Urai Tanggal" field
                uraiTglInput.val(formattedDate);
            } else {
                uraiTglInput.val('');
            }
        }
        
        // Helper function to convert day (1-31) to words
        function convertDayToWords(day) {
            const daysInWords = [
                '', 'satu', 'dua', 'tiga', 'empat', 'lima', 'enam', 'tujuh', 'delapan', 'sembilan',
                'sepuluh', 'sebelas', 'dua belas', 'tiga belas', 'empat belas', 'lima belas', 'enam belas',
                'tujuh belas', 'delapan belas', 'sembilan belas', 'dua puluh', 'dua puluh satu', 'dua puluh dua',
                'dua puluh tiga', 'dua puluh empat', 'dua puluh lima', 'dua puluh enam', 'dua puluh tujuh', 
                'dua puluh delapan', 'dua puluh sembilan', 'tiga puluh', 'tiga puluh satu'
            ];
            return daysInWords[day];
        }
        
        // Helper function to convert year (e.g., 2025) to words
        function convertYearToWords(year) {
            const yearInWords = {
                2025: 'dua ribu dua lima',
                2024: 'dua ribu dua empat',
                2023: 'dua ribu dua tiga',
                // Add more years as needed
            };
            return yearInWords[year] || year;  // Default to year if not found
        }
        
        
        function showSweetAlert() {
            Swal.fire({
                title: 'Print unavailable',
                text: 'Anda belum bisa Print data ini karena perusahaan belum melakukan pengajuan.',
                icon: 'warning',
                confirmButtonText: 'OK'
            });
        }
        function restore_(nama, id){
                Swal.fire({
                    title: `Apakah anda yakin ingin memulihkan file ${nama}?`,
                    showCancelButton: true,
                    confirmButtonText: 'Pulihkan',
                    cancelButtonText: 'Batal',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: `/manage_panel/trans_spk/restore/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                    onOpen: () => {
                                        swal.showLoading();
                                    }
                                });
                            },
                            success: function(response){
                                Swal.fire(`Data SPK berhasil dipulihkan!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "/manage_panel/trans_spk/";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Data SPK gagal dipulihkan!`, '', 'error');
                            }
                        });
                        
                    }
                });
            }
            function delete_(action, nama, id){
                let pesan = action == 'soft_delete' ? "arsipkan" : "hapus";
                let confirmation = action == 'soft_delete' ? "Arsipkan" : "Hapus";
                Swal.fire({
                    title: `Apakah kamu yakin ingin meng${pesan} file ${nama}?`,
                    showCancelButton: true,
                    confirmButtonText: confirmation,
                    cancelButtonText: 'Batal',
                    }).then((result) => {
                    if (result.isConfirmed) {
                        $.ajax({
                            url: `/manage_panel/trans_spk/${action}/${id}`,
                            data: {},
                            dataType: "html",
                            timeout: 10000,
                            beforeSend: function() {
                                Swal.fire({
                                    title: 'Memproses.........',
                                    allowEscapeKey: false,
                                    allowOutsideClick: false,
                                    showCancelButton: false,
                                    showConfirmButton: false,
                                });
                                Swal.showLoading();
                            },
                            success: function(response){
                                Swal.fire(`Data SPK berhasil di${pesan}!`, '', 'success');
                                setTimeout(function(){
                                    window.location.href = "/manage_panel/trans_spk/";
                                }, 2000); 
                            },
                            error: function (xhr, ajaxOptions, thrownError) {
                                Swal.fire(`Data SPK gagal di${pesan}!`, '', 'error');
                            }
                        });
                        
                    }
                });
            }
    </script>
{% endblock scripts_bawah %}